C To obtain the spacing of planes, when the Miller indices are not
C  those which are systematically absent
C
      SUBROUTINE MAP_CRYSTAL_DSP(F,H,K,L,JTYPE,JLOG,AD)
      IMPLICIT NONE
C
C AD is the spacing of the planes with Miller indices (HKL)
C The metric tensor F converts the components from reciprocal to
C  real space. 
C The metric tensor G converts the components from real to reciprocal
C  space, and G is the inverse of F and vice-versa.
C
      REAL F(9),H,K,L,AD,MAP_UTIL_MAG,H1,K1,L1,A
      INTEGER JTYPE,JLOG
C
C JTYPE represents the lattice type, with 1=primitive etc.
C   For further details on JTYPE see subroutine TYPE
C Note that there are no systematic absences for a primitive lattice
C   so that the calculation can jump straight away to statement 6.
C For all other lattice types, subroutine TYPE determines whether 
C   there is a systematic absence (i.e. JLOG=1) and the spacing is
C   calculated only if there is no absence
      IF(JTYPE .EQ. 1)GOTO 10
        CALL MAP_CRYSTAL_TYPE(H,K,L,JTYPE,JLOG)
      IF(JLOG .EQ. 1)GOTO 20
C Calcuate spacing using a scalar product of the real and reciprocal
C   lattice components of the same vector
 10       CALL MAP_UTIL_TRANS(F,H,K,L,H1,K1,L1)
C
          A=MAP_UTIL_MAG(H,K,L,H1,K1,L1)
          A=SQRT(A)
          AD=1.0/A
C
 20    RETURN
       END
